// Copyright 2013 The Flutter Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// Autogenerated from Pigeon (v10.1.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package io.flutter.plugins.googlesignin;

import android.util.Log;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MessageCodec;
import io.flutter.plugin.common.StandardMessageCodec;
import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;

/** Generated class from Pigeon. */
@SuppressWarnings({"unused", "unchecked", "CodeBlock2Expr", "RedundantSuppression", "serial"})
public class Messages {

  /** Error class for passing custom error details to Flutter via a thrown PlatformException. */
  public static class FlutterError extends RuntimeException {

    /** The error code. */
    public final String code;

    /** The error details. Must be a datatype supported by the api codec. */
    public final Object details;

    public FlutterError(@NonNull String code, @Nullable String message, @Nullable Object details) {
      super(message);
      this.code = code;
      this.details = details;
    }
  }

  @NonNull
  protected static ArrayList<Object> wrapError(@NonNull Throwable exception) {
    ArrayList<Object> errorList = new ArrayList<Object>(3);
    if (exception instanceof FlutterError) {
      FlutterError error = (FlutterError) exception;
      errorList.add(error.code);
      errorList.add(error.getMessage());
      errorList.add(error.details);
    } else {
      errorList.add(exception.toString());
      errorList.add(exception.getClass().getSimpleName());
      errorList.add(
          "Cause: " + exception.getCause() + ", Stacktrace: " + Log.getStackTraceString(exception));
    }
    return errorList;
  }

  /** Pigeon version of SignInOption. */
  public enum SignInType {
    /** Default configuration. */
    STANDARD(0),
    /** Recommended configuration for game sign in. */
    GAMES(1);

    final int index;

    private SignInType(final int index) {
      this.index = index;
    }
  }

  /**
   * Pigeon version of SignInInitParams.
   *
   * <p>See SignInInitParams for details.
   *
   * <p>Generated class from Pigeon that represents data sent in messages.
   */
  public static final class InitParams {
    private @NonNull List<String> scopes;

    public @NonNull List<String> getScopes() {
      return scopes;
    }

    public void setScopes(@NonNull List<String> setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"scopes\" is null.");
      }
      this.scopes = setterArg;
    }

    private @NonNull SignInType signInType;

    public @NonNull SignInType getSignInType() {
      return signInType;
    }

    public void setSignInType(@NonNull SignInType setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"signInType\" is null.");
      }
      this.signInType = setterArg;
    }

    private @Nullable String hostedDomain;

    public @Nullable String getHostedDomain() {
      return hostedDomain;
    }

    public void setHostedDomain(@Nullable String setterArg) {
      this.hostedDomain = setterArg;
    }

    private @Nullable String clientId;

    public @Nullable String getClientId() {
      return clientId;
    }

    public void setClientId(@Nullable String setterArg) {
      this.clientId = setterArg;
    }

    private @Nullable String serverClientId;

    public @Nullable String getServerClientId() {
      return serverClientId;
    }

    public void setServerClientId(@Nullable String setterArg) {
      this.serverClientId = setterArg;
    }

    private @NonNull Boolean forceCodeForRefreshToken;

    public @NonNull Boolean getForceCodeForRefreshToken() {
      return forceCodeForRefreshToken;
    }

    public void setForceCodeForRefreshToken(@NonNull Boolean setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"forceCodeForRefreshToken\" is null.");
      }
      this.forceCodeForRefreshToken = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    InitParams() {}

    public static final class Builder {

      private @Nullable List<String> scopes;

      public @NonNull Builder setScopes(@NonNull List<String> setterArg) {
        this.scopes = setterArg;
        return this;
      }

      private @Nullable SignInType signInType;

      public @NonNull Builder setSignInType(@NonNull SignInType setterArg) {
        this.signInType = setterArg;
        return this;
      }

      private @Nullable String hostedDomain;

      public @NonNull Builder setHostedDomain(@Nullable String setterArg) {
        this.hostedDomain = setterArg;
        return this;
      }

      private @Nullable String clientId;

      public @NonNull Builder setClientId(@Nullable String setterArg) {
        this.clientId = setterArg;
        return this;
      }

      private @Nullable String serverClientId;

      public @NonNull Builder setServerClientId(@Nullable String setterArg) {
        this.serverClientId = setterArg;
        return this;
      }

      private @Nullable Boolean forceCodeForRefreshToken;

      public @NonNull Builder setForceCodeForRefreshToken(@NonNull Boolean setterArg) {
        this.forceCodeForRefreshToken = setterArg;
        return this;
      }

      public @NonNull InitParams build() {
        InitParams pigeonReturn = new InitParams();
        pigeonReturn.setScopes(scopes);
        pigeonReturn.setSignInType(signInType);
        pigeonReturn.setHostedDomain(hostedDomain);
        pigeonReturn.setClientId(clientId);
        pigeonReturn.setServerClientId(serverClientId);
        pigeonReturn.setForceCodeForRefreshToken(forceCodeForRefreshToken);
        return pigeonReturn;
      }
    }

    @NonNull
    ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(6);
      toListResult.add(scopes);
      toListResult.add(signInType == null ? null : signInType.index);
      toListResult.add(hostedDomain);
      toListResult.add(clientId);
      toListResult.add(serverClientId);
      toListResult.add(forceCodeForRefreshToken);
      return toListResult;
    }

    static @NonNull InitParams fromList(@NonNull ArrayList<Object> list) {
      InitParams pigeonResult = new InitParams();
      Object scopes = list.get(0);
      pigeonResult.setScopes((List<String>) scopes);
      Object signInType = list.get(1);
      pigeonResult.setSignInType(signInType == null ? null : SignInType.values()[(int) signInType]);
      Object hostedDomain = list.get(2);
      pigeonResult.setHostedDomain((String) hostedDomain);
      Object clientId = list.get(3);
      pigeonResult.setClientId((String) clientId);
      Object serverClientId = list.get(4);
      pigeonResult.setServerClientId((String) serverClientId);
      Object forceCodeForRefreshToken = list.get(5);
      pigeonResult.setForceCodeForRefreshToken((Boolean) forceCodeForRefreshToken);
      return pigeonResult;
    }
  }

  /**
   * Pigeon version of GoogleSignInUserData.
   *
   * <p>See GoogleSignInUserData for details.
   *
   * <p>Generated class from Pigeon that represents data sent in messages.
   */
  public static final class UserData {
    private @Nullable String displayName;

    public @Nullable String getDisplayName() {
      return displayName;
    }

    public void setDisplayName(@Nullable String setterArg) {
      this.displayName = setterArg;
    }

    private @NonNull String email;

    public @NonNull String getEmail() {
      return email;
    }

    public void setEmail(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"email\" is null.");
      }
      this.email = setterArg;
    }

    private @NonNull String id;

    public @NonNull String getId() {
      return id;
    }

    public void setId(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"id\" is null.");
      }
      this.id = setterArg;
    }

    private @Nullable String photoUrl;

    public @Nullable String getPhotoUrl() {
      return photoUrl;
    }

    public void setPhotoUrl(@Nullable String setterArg) {
      this.photoUrl = setterArg;
    }

    private @Nullable String idToken;

    public @Nullable String getIdToken() {
      return idToken;
    }

    public void setIdToken(@Nullable String setterArg) {
      this.idToken = setterArg;
    }

    private @Nullable String serverAuthCode;

    public @Nullable String getServerAuthCode() {
      return serverAuthCode;
    }

    public void setServerAuthCode(@Nullable String setterArg) {
      this.serverAuthCode = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    UserData() {}

    public static final class Builder {

      private @Nullable String displayName;

      public @NonNull Builder setDisplayName(@Nullable String setterArg) {
        this.displayName = setterArg;
        return this;
      }

      private @Nullable String email;

      public @NonNull Builder setEmail(@NonNull String setterArg) {
        this.email = setterArg;
        return this;
      }

      private @Nullable String id;

      public @NonNull Builder setId(@NonNull String setterArg) {
        this.id = setterArg;
        return this;
      }

      private @Nullable String photoUrl;

      public @NonNull Builder setPhotoUrl(@Nullable String setterArg) {
        this.photoUrl = setterArg;
        return this;
      }

      private @Nullable String idToken;

      public @NonNull Builder setIdToken(@Nullable String setterArg) {
        this.idToken = setterArg;
        return this;
      }

      private @Nullable String serverAuthCode;

      public @NonNull Builder setServerAuthCode(@Nullable String setterArg) {
        this.serverAuthCode = setterArg;
        return this;
      }

      public @NonNull UserData build() {
        UserData pigeonReturn = new UserData();
        pigeonReturn.setDisplayName(displayName);
        pigeonReturn.setEmail(email);
        pigeonReturn.setId(id);
        pigeonReturn.setPhotoUrl(photoUrl);
        pigeonReturn.setIdToken(idToken);
        pigeonReturn.setServerAuthCode(serverAuthCode);
        return pigeonReturn;
      }
    }

    @NonNull
    ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(6);
      toListResult.add(displayName);
      toListResult.add(email);
      toListResult.add(id);
      toListResult.add(photoUrl);
      toListResult.add(idToken);
      toListResult.add(serverAuthCode);
      return toListResult;
    }

    static @NonNull UserData fromList(@NonNull ArrayList<Object> list) {
      UserData pigeonResult = new UserData();
      Object displayName = list.get(0);
      pigeonResult.setDisplayName((String) displayName);
      Object email = list.get(1);
      pigeonResult.setEmail((String) email);
      Object id = list.get(2);
      pigeonResult.setId((String) id);
      Object photoUrl = list.get(3);
      pigeonResult.setPhotoUrl((String) photoUrl);
      Object idToken = list.get(4);
      pigeonResult.setIdToken((String) idToken);
      Object serverAuthCode = list.get(5);
      pigeonResult.setServerAuthCode((String) serverAuthCode);
      return pigeonResult;
    }
  }

  public interface Result<T> {
    @SuppressWarnings("UnknownNullness")
    void success(T result);

    void error(@NonNull Throwable error);
  }

  private static class GoogleSignInApiCodec extends StandardMessageCodec {
    public static final GoogleSignInApiCodec INSTANCE = new GoogleSignInApiCodec();

    private GoogleSignInApiCodec() {}

    @Override
    protected Object readValueOfType(byte type, @NonNull ByteBuffer buffer) {
      switch (type) {
        case (byte) 128:
          return InitParams.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 129:
          return UserData.fromList((ArrayList<Object>) readValue(buffer));
        default:
          return super.readValueOfType(type, buffer);
      }
    }

    @Override
    protected void writeValue(@NonNull ByteArrayOutputStream stream, Object value) {
      if (value instanceof InitParams) {
        stream.write(128);
        writeValue(stream, ((InitParams) value).toList());
      } else if (value instanceof UserData) {
        stream.write(129);
        writeValue(stream, ((UserData) value).toList());
      } else {
        super.writeValue(stream, value);
      }
    }
  }

  /** Generated interface from Pigeon that represents a handler of messages from Flutter. */
  public interface GoogleSignInApi {
    /** Initializes a sign in request with the given parameters. */
    void init(@NonNull InitParams params);
    /** Starts a silent sign in. */
    void signInSilently(@NonNull Result<UserData> result);
    /** Starts a sign in with user interaction. */
    void signIn(@NonNull Result<UserData> result);
    /** Requests the access token for the current sign in. */
    void getAccessToken(
        @NonNull String email, @NonNull Boolean shouldRecoverAuth, @NonNull Result<String> result);
    /** Signs out the current user. */
    void signOut(@NonNull Result<Void> result);
    /** Revokes scope grants to the application. */
    void disconnect(@NonNull Result<Void> result);
    /** Returns whether the user is currently signed in. */
    @NonNull
    Boolean isSignedIn();
    /** Clears the authentication caching for the given token, requiring a new sign in. */
    void clearAuthCache(@NonNull String token, @NonNull Result<Void> result);
    /** Requests access to the given scopes. */
    void requestScopes(@NonNull List<String> scopes, @NonNull Result<Boolean> result);

    /** The codec used by GoogleSignInApi. */
    static @NonNull MessageCodec<Object> getCodec() {
      return GoogleSignInApiCodec.INSTANCE;
    }
    /**
     * Sets up an instance of `GoogleSignInApi` to handle messages through the `binaryMessenger`.
     */
    static void setup(@NonNull BinaryMessenger binaryMessenger, @Nullable GoogleSignInApi api) {
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.init", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                InitParams paramsArg = (InitParams) args.get(0);
                try {
                  api.init(paramsArg);
                  wrapped.add(0, null);
                } catch (Throwable exception) {
                  ArrayList<Object> wrappedError = wrapError(exception);
                  wrapped = wrappedError;
                }
                reply.reply(wrapped);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.signInSilently", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                Result<UserData> resultCallback =
                    new Result<UserData>() {
                      public void success(UserData result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.signInSilently(resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.signIn", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                Result<UserData> resultCallback =
                    new Result<UserData>() {
                      public void success(UserData result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.signIn(resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.getAccessToken", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                String emailArg = (String) args.get(0);
                Boolean shouldRecoverAuthArg = (Boolean) args.get(1);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.getAccessToken(emailArg, shouldRecoverAuthArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.signOut", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.signOut(resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.disconnect", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.disconnect(resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.isSignedIn", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                try {
                  Boolean output = api.isSignedIn();
                  wrapped.add(0, output);
                } catch (Throwable exception) {
                  ArrayList<Object> wrappedError = wrapError(exception);
                  wrapped = wrappedError;
                }
                reply.reply(wrapped);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.clearAuthCache", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                String tokenArg = (String) args.get(0);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.clearAuthCache(tokenArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger, "dev.flutter.pigeon.GoogleSignInApi.requestScopes", getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                List<String> scopesArg = (List<String>) args.get(0);
                Result<Boolean> resultCallback =
                    new Result<Boolean>() {
                      public void success(Boolean result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.requestScopes(scopesArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
    }
  }
}
